# Class ClosableLock

java.lang.Object
java.util.concurrent.locks.ReentrantLock
org.mariadb.jdbc.client.util.ClosableLock

All Implemented Interfaces:
  `Serializable, AutoCloseable, Lock`

public final class ClosableLock extends ReentrantLock implements AutoCloseable
Utility class to permit use AutoClosable, ensuring proper lock release.

See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`ClosableLock()`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
`ClosableLock`
`closeableLock()`
Default constructor, retaining lock.

### Methods inherited from class ReentrantLock

`getHoldCount, getOwner, getQueuedThreads, getQueueLength, getWaitingThreads, getWaitQueueLength, hasQueuedThread, hasQueuedThreads, hasWaiters, isFair, isHeldByCurrentThread, isLocked, lock, lockInterruptibly, newCondition, toString, tryLock, tryLock, unlock`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ClosableLock

public ClosableLock()

## Method Details

### closeableLock

public ClosableLock closeableLock()
Default constructor, retaining lock.

Returns:
  Closable lock

### close

public void close()

Specified by:
  `close` in interface `AutoCloseable`